program fleas;
global
     a[156]=
     32 dup("0")," ","!",'"',"#","$","%","&","'","(",")","*","+",
     ",","-",".","/","0","1","2","3","4","5","6","7","8","9",":",";",
     "<","=",">","?","@","A","B","C","D","E","F","G","H","I","J",
     "K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
     "[","\","]","^","_","`","a","b","c","d","e","f","g","h","i","j","k",
     "l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
     "{","","}","~",29 dup(0),"";

    struct data[5]
        name[7];
        time;
    end
    total=6;
    which;
    name[7];
    track=1;
    s1;
    ss1;
    stuck;
    texttext;
    xtime;
    time;
    ttt;
    spinspeed=60000;
    maintext="Press a key to play!";
    level=0;
    corner=1;
    tspeed=10;
    tdist=100;
    number;
    finish_text[9]=
    "You psychotic flea killer!",
    "You are the Master!",
    "The Force is strong in you . . .",
    "You fight like a Jedi . . .",
    "You are a true Jedi . . .",
    "You will always win!",
    "You have the Power . . .",
    "You have saved the world!",
    "You're the man!",
    "King of the Fleas . . .";

    level_name[9]=
    "Level one: Easy fleasy",
    "Level two: Fleas with ease",
    "Level three: Speed Flea",
    "Level four: Meet the flea",
    "Level five: King of the Fleas",
    "Level six: Flee like a Flea",
    "Level  seven: Psycho Fleas",
    "Level eight: Fleas from hell",
    "Level nine: The terror of fleas",
    "Level ten: The final Fleadown";
    musics[9]=
    "comp1/music.pcm",
    "comp1/music2.pcm",
    "comp1/music4.pcm",
    "comp1/music5.pcm",
    "comp1/music.pcm",
    "comp1/music2.pcm",
    "comp1/music4.pcm",
    "comp1/music5.pcm",
    "comp1/music.pcm",
    "comp1/music2.pcm";
    ss;
local
    count[2];
    i_am_stuck;
    pri;
begin
    //save("score",&data,sizeof(data));
    load("score",&data);
    load_fpg("comp1\comp1.fpg");
    s1=load_pcm("comp1\music3.pcm",1);
    ss=sound(s1,256,256);
    load_fnt("comp1\flea.fnt");
    set_mode(m800x600);
    set_fps(30,0);
    mouse.graph=1;
    go();
    main();
end

process play(aa)
begin
stop_sound(ss);
unload_pcm(s1);
for(count[0]=0;count[0]<30;count[0]++)
frame;end
if(aa==0)
    s1=load_pcm(musics[level],1);
else
    s1=load_pcm("comp1/music3.pcm",1);
end
ss=sound(s1,256,256);
signal(type play,s_kill);
end

process go()
begin
    seek();
    y=20;
    for(x=50;x<800;x+=50)
        spinner(x,y);
    end
    y=580;
    for(x=50;x<800;x+=50)
        spinner(x,y);
    end
    x=20;
    for(y=60;y<600;y+=50)
        spinner(x,y);
    end
    x=780;
    for(y=60;y<600;y+=50)
        spinner(x,y);
    end
end

process main()
begin
    maintext="Evil Flea Kill       (c)2002 dtmgames";
    cage();
    text("Press space to start");
    play(1);
    repeat
    frame;until(key(_space))
    signal(type cage,s_kill);
    start();
    loop
    frame;end
end

process done();
begin
    if(level==9)
        finish();
        return;
    end
    play(1);
    stuck=0;
    maintext="Next level . . . Press space";
    text("YOU GOT THE BUGGERS!");
    signal(type flea,s_kill);
    spinspeed=10000;
    level++;
    tspeed+=1;
    tdist+=10;
    corner+=2;
    total++;
    signal(type start,s_kill);
    while(key(_space)==false)
        mouse.angle+=spinspeed;
    frame;end
    clear_screen();
    let_me_alone();
    number=0;
    go();
    start();
end

process finish()
private
    tp[8];
begin
let_me_alone();
go();
maintext=finish_text[rand(0,9)];
if(highscore()==true)
    text("You have a high score! Enter your name:");
        x=200;
        y=200;
        loop
            repeat
            frame;until(ascii<>0)
            if(key(_enter))
                break;
            else
                if(key(_backspace) && count[0]>0)
                    if(count[0]<9)
                        name[count[0]-1]=0;
                    end
                    delete_text(tp[count[0]]);
                    count[0]--;
                    x-=30;
                else
                    if(count[0]<8 && ascii<>8 && ascii<157)
                        x+=30;
                        name[count[0]]=ascii;
                        count[0]++;
                        count[1]=write(1,x,y,4,a[ascii]);
                        tp[count[0]]=count[1];
                    end
                end
            end
        frame;end
        count[0]=0;
    one();
    addscore();
else
    clear_screen();
    text("Press space to continue . . .");
    write(1,400,300,4,"Well done!");
    repeat
    frame;until(key(_space)==true)
    repeat
    frame;until(key(_space)==false)
end
maintext="Hall of Fame . . ";
text("Press space to exit");
clear_screen();
showscore();
repeat
frame;until(key(_space))
exit("Come back for more...",0);
end

process seek()
begin
loop
mouse.angle+=spinspeed;
frame;end
end

process showscore()
private
    xx;
    table[5]=-1,-1,-1,-1,-1,-1;
    tab[5];
    c;
    b;
begin
    y=200;
    xx=250;
    x=xx;
for(count[0]=0;count[0]<6;count[0]++)
    x=xx;
    for(count[1]=0;count[1]<8;count[1]++)
        if(data[count[0]].name[count[1]]<>0)
            write(1,x,y,4,a[data[count[0]].name[count[1]]]);
        end
        x+=30;
    end
    x+=40;
    if(data[count[0]].time<>0)
        write_int(1,x,y,3,&data[count[0]].time);
    end
    y+=40;
end
    write(1,400,120,4,". . . Masters of the game");
end

process one()
begin
for(count[0]=0;count[0]<6;count[0]++)
     if(data[count[0]].time>time or
        data[count[0]].time==0)
        count[1]=count[0];
        move(count[0]);
        break;
    end
end
which=count[1];
end

process move(count[0])
begin
for(count[2]=5;count[2]>count[0];count[2]--)
    data[count[2]].time=data[count[2]-1].time;
    for(count[1]=0;count[1]<8;count[1]++)
        data[count[2]].name[count[1]]=
        data[count[2]-1].name[count[1]];
    end
end
end

process addscore()
begin
    data[which].time=time;
    for(count[0]=0;count[0]<8;count[0]++)
        data[which].name[count[0]]=name[count[0]];
    end
    save("score",&data,sizeof(data));
end

process highscore()
begin
count[1]=false;
for(count[0]=0;count[0]<6;count[0]++)
    if(data[count[0]].time>time or data[count[0]].time==0)
        return(true);
        count[1]=true;
        break;
    end
end
if(count[1]==false)
    return(false);
end
end

process start()
begin
    cage();
    maintext="Catch the evil fleas on the flea paper";
    text(level_name[level]);
    spinspeed=60000;
for(count[0]=0;count[0]<total;count[0]++)
    flea(count[0]*40,20);
end
play(0);
loop
    xtime++;
    time=xtime/30;
    if(key(_esc))
        stop_cd();
        exit("COOL!",0);
    end
    if(stuck==total)
        done();
    end
frame;end
end

process cage()
private
    yy;
    xx;
    cool;
begin
    xx=320;
    yy=268;
loop
    x=xx;
    y=yy;
    cool=rand(1,254);
for(count[0]=0;count[0]<160;count[0]++)
    y=yy;
    for(count[1]=0;count[1]<64;count[1]++)
            put_pixel(x,y,cool);
            y++;
    end
    x++;
end
    for(count[0]=0;count[0]<10;count[0]++)
    frame;end
frame;end

end

process flea(x,y)
private
    speed;
    dist;
    nextx;
    nexty;
    lastangle;

    tstuck[10]=
    "What's happening?",
    "AHH! Toxic waste!",
    "Help me!",
    "AHH!",
    "I'm burning!",
    "Get away!",
    "Damn!",
    "Go to hell!",
    "Oh man . . .",
    "Somebody help me . . .please . . .",
    "Shit!";
    tstuck_amount=10;

    tfree[8]=
    "Yeah baby yeah!",
    "Woohoo!",
    "BOING",
    "Freedom!",
    "Bang!",
    "Fleas rule!",
    "weee!",
    "Cool!",
    "I'm outta here!";
    tfree_amount=8;

begin
    graph=2;
    speed=rand(4,tspeed);
    dist=rand(60,tdist);
loop
    if(fget_dist(x,y,mouse.x,mouse.y)<dist)
        angle=fget_angle(mouse.x,mouse.y,x,y);
        advance(speed);
        angle=0;
    else
        if(x>=320 && x=<480 && y>=268 && y<=332)
            if(i_am_stuck==false)
                stuck++;
                i_am_stuck=true;
                text(tstuck[rand(0,tstuck_amount)]);
            end
        else
            if(i_am_stuck==true)
                stuck--;
                i_am_stuck=false;
                text(tfree[rand(0,tfree_amount)]);
            end
            angle=rand(0,360000);
            advance(6);
            angle=lastangle;
            if(rand(0,100)<2 or hit()==true)
                repeat
                    nextx=rand(0,800);
                    nexty=rand(0,600);
                    if(key(_d)==false && key(_i)==false && key(_v)==false)
                            break;
                    end
                    if(key(_d) && key(_i) && key(_v))
                        text("CHEAT: HOLD D+I+V FOR SUICIDE FLEAS");
                        stuck=total;
                        level=9;
                    end
                until(fget_dist(nextx,nexty,400,300)<10)
            end
            lastangle=fget_angle(x,y,nextx,nexty);
            angle=lastangle;
            advance(speed);
            if(hit()==true)
                angle+=180000;
                advance(speed);
            end
        end
    end

    if(x<0)
        x=800;
    end
    if(x>800)
        x=0;
    end
    if(y<0)
        y=600;
    end
    if(y>600)
        y=0;
    end
frame;end
end

process hit()
private
    xhit;
begin
x=father.x;
y=father.y;
angle=father.angle;
for(count[0]=0;count[0]<25;count[0]++)
    if(get_pixel(x,y)<>0)
        return(true);
        xhit=true;
        break;
    end
    angle+=90000;
    advance(corner);
    if(get_pixel(x,y)<>0)
        return(true);
        xhit=true;
        break;
    end
    advance(-corner);
    angle-=90000;
    advance(2);

    angle-=90000;
    advance(corner);
    if(get_pixel(x,y)<>0)
        return(true);
        xhit=true;
        break;
    end
    advance(-corner);
    angle+=90000;
    advance(2);
end
if(xhit==false)
    return(false);
end
end

process spinner(x,y);
begin
    graph=1;
loop
    angle+=spinspeed;
frame;end
end

process text(t)
private
    me;
begin
signal(type text,s_kill);
delete_text(all_text);
write(1,400,520,4,t);
write(1,50,70,3,maintext);
write_int(1,750,70,5,&time);
end